VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4530
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   5130
   LinkTopic       =   "Form1"
   ScaleHeight     =   4530
   ScaleWidth      =   5130
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pbGame 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   3855
      Left            =   240
      ScaleHeight     =   3825
      ScaleWidth      =   4545
      TabIndex        =   0
      Top             =   240
      Width           =   4575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Const cols As Long = 100, rows As Long = 100, cellsCount As Long = rows * cols
Dim cells As New Collection
Dim cellSize As Long, curCell As gameCell, emptyCell As gameCell
Dim Cursors(0 To 5) As IPictureDisp
Dim dX() As Integer, dY() As Integer
Dim t As Long

Private Sub Form_Load()
   t = GetTickCount
   Dim i As Long, j As Long, c As gameCell
   ReDim dX(-1 * (cols - 1) To cols - 1)
   ReDim dY(-1 * (rows - 1) To rows - 1)
   For i = 1 To rows
       dY(i - 1) = 4: dY(-i + 1) = 4
       For j = 1 To cols
           dX(j - 1) = 4: dY(-j + 1) = 4
           Set c = New gameCell
           c.pos = (i - 1) * cols + j
           c.row = i: c.col = j: c.digit = c.pos
           cells.Add c, CStr(c.pos)
       Next j
   Next i
   dX(-1) = 1: dX(1) = 2: dY(-1) = 0: dY(1) = 3
   Set emptyCell = cells(CStr(cellsCount))
   Set Cursors(0) = LoadPicture(App.Path & "\Up.cur")
   Set Cursors(1) = LoadPicture(App.Path & "\Left.cur")
   Set Cursors(2) = LoadPicture(App.Path & "\Right.cur")
   Set Cursors(3) = LoadPicture(App.Path & "\Down.cur")
   Set Cursors(4) = LoadPicture(App.Path & "\None.cur")
   pbGame.MousePointer = vbCustom
   Shuffle 500
   Debug.Print "form_load = " & GetTickCount - t
End Sub

Private Sub Form_Resize()
   If Me.WindowState = vbMinimized Then Exit Sub
   t = GetTickCount
   cellSize = Min(ScaleWidth / cols, ScaleHeight / rows)
   Dim w As Long, h As Long
   w = cellSize * cols: h = cellSize * rows
   pbGame.Move ScaleWidth / 2 - w / 2, ScaleHeight / 2 - h / 2, w, h
   RedrawCells
   Debug.Print "form_resize = " & GetTickCount - t
   t = GetTickCount
   DoClicks 10000
   Debug.Print "clicks*10000 = " & GetTickCount - t
End Sub

Private Sub pbGame_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
   Dim idx As Long
   Static lastIdx As Long
   idx = Int(Y / cellSize) * cols + Int(X / cellSize) + 1
   If idx = lastIdx Then Exit Sub
   lastIdx = idx
   Set curCell = cells(CStr(idx))
   pbGame.MouseIcon = Cursors(GetMoveDir)
End Sub

Private Sub pbGame_Click()
   If GetMoveDir = 4 Then Exit Sub
   SwapCells
   PrintCell emptyCell
   PrintCell curCell
   pbGame.MouseIcon = Cursors(4)
   If IsCorrect Then MsgBox "Done!"
End Sub

Private Sub Shuffle(n As Long)
   Dim i As Long, X As Long
   Dim tc As Collection
   Dim gc As gameCell
   Randomize Timer
   X = 4
   For i = 1 To n
      Set tc = New Collection
      If emptyCell.col > 1 And (X <> 2) Then tc.Add cells(CStr(emptyCell.pos - 1))
      If emptyCell.col < cols And (X <> 1) Then tc.Add cells(CStr(emptyCell.pos + 1))
      If emptyCell.row > 1 And (X <> 3) Then tc.Add cells(CStr(emptyCell.pos - cols))
      If emptyCell.row < rows And (X <> 0) Then tc.Add cells(CStr(emptyCell.pos + cols))
      Set curCell = tc(GetRandom(1, tc.Count))
      'Debug.Print "=>" & curCell.digit;
      SwapCells
      X = GetMoveDir
   Next
End Sub

Private Sub RedrawCells()
   Dim i As Long, j As Long, s As String, c As gameCell
   pbGame.Cls
   For i = 1 To rows
      pbGame.Line (0, cellSize * i)-(ScaleWidth, cellSize * i)
      For j = 1 To cols
          If i = 1 Then pbGame.Line (cellSize * j, 0)-(cellSize * j, ScaleHeight)
          s = (i - 1) * cols + j
          Set c = cells(s)
          c.top = (i - 1) * cellSize
          c.left = (j - 1) * cellSize
          PrintCell c
      Next
   Next
End Sub

Private Sub SwapCells()
   Dim tempCell As gameCell
   emptyCell.digit = curCell.digit
   curCell.digit = cellsCount
   Set tempCell = emptyCell
   Set emptyCell = curCell
   Set curCell = tempCell
End Sub

Private Sub PrintCell(c As gameCell)
   pbGame.Line (c.left + 16, c.top + 16)-(c.left + cellSize - 16, c.top + cellSize - 16), pbGame.BackColor, BF
   If c.digit = cellsCount Then Exit Sub
   Dim s As String
   s = c.digit
   With pbGame
      .CurrentX = c.left + (cellSize - .TextWidth(s)) / 2
      .CurrentY = c.top + (cellSize - .TextHeight(s)) / 2
   End With
   pbGame.Print s
End Sub

Private Function GetMoveDir() As Long
   GetMoveDir = 4
   If curCell.digit = cellsCount Then Exit Function
   If curCell.row = emptyCell.row Then
      GetMoveDir = dX(emptyCell.col - curCell.col)
   ElseIf curCell.col = emptyCell.col Then
      GetMoveDir = dY(emptyCell.row - curCell.row)
   End If
End Function
Private Function Min(X As Long, Y As Long) As Long
   If X > Y Then Min = Y Else Min = X
End Function
Private Function GetRandom(X As Long, ByVal Y As Long) As Long
   GetRandom = Int((Y - X + 1) * Rnd + X)
End Function

Private Function IsCorrect() As Boolean
   Dim gc As gameCell
   For Each gc In cells
      If gc.digit <> gc.pos Then Exit Function
   Next
   IsCorrect = True
End Function

Private Sub DoClicks(nRounds As Long)
   Dim X As Single, Y As Single, i As Long
   For i = 1 To nRounds
      X = GetRandom(16, pbGame.Width - 16)
      Y = GetRandom(16, pbGame.Height - 16)
      pbGame_MouseMove 0, 0, X, Y
      pbGame_Click
   Next i
End Sub
